(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ngx-webappcommons-mobile'), require('ngx-angularcommons-core'), require('@angular/common'), require('ngx-webappcommons-core')) :
    typeof define === 'function' && define.amd ? define('ngx-webappcommons-keyboard', ['exports', '@angular/core', 'ngx-webappcommons-mobile', 'ngx-angularcommons-core', '@angular/common', 'ngx-webappcommons-core'], factory) :
    (global = global || self, factory(global['ngx-webappcommons-keyboard'] = {}, global.ng.core, global['ngx-webappcommons-mobile'], global['ngx-angularcommons-core'], global.ng.common, global.ngxWebappcommonsCore));
}(this, (function (exports, core, ngxWebappcommonsMobile, ngxAngularcommonsCore, common, ngxWebappcommonsCore) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var FULL_KEYBOARD = {
        default: 'lower',
        sets: {
            lower: { label: 'a-z', keys: [
                    [
                        { cancel: true, icon: 'cancel' },
                        { character: '1' },
                        { character: '2' },
                        { character: '3' },
                        { character: '4' },
                        { character: '5' },
                        { character: '6' },
                        { character: '7' },
                        { character: '8' },
                        { character: '9' },
                        { character: '0' },
                        { backspace: true, icon: 'backspace' }
                    ], [
                        null,
                        { character: 'q' },
                        { character: 'w' },
                        { character: 'e' },
                        { character: 'r' },
                        { character: 't' },
                        { character: 'y' },
                        { character: 'u' },
                        { character: 'i' },
                        { character: 'o' },
                        { character: 'p' },
                        { ok: true, icon: 'check_circle' }
                    ], [
                        { set: 'upper', span: 2 },
                        { character: 'a' },
                        { character: 's' },
                        { character: 'd' },
                        { character: 'f' },
                        { character: 'g' },
                        { character: 'h' },
                        { character: 'j' },
                        { character: 'k' },
                        { character: 'l' }
                    ], [
                        { set: 'symbols', span: 2 },
                        { character: 'z' },
                        { character: 'x' },
                        { character: 'c' },
                        { character: 'v' },
                        { character: 'b' },
                        { character: 'n' },
                        { character: 'm' }
                    ], [
                        null,
                        null,
                        null,
                        null,
                        { space: true, span: 4 }
                    ]
                ] },
            upper: { label: 'A-Z', keys: [
                    [
                        { cancel: true, icon: 'cancel' },
                        { character: '1' },
                        { character: '2' },
                        { character: '3' },
                        { character: '4' },
                        { character: '5' },
                        { character: '6' },
                        { character: '7' },
                        { character: '8' },
                        { character: '9' },
                        { character: '0' },
                        { backspace: true, icon: 'backspace' }
                    ], [
                        null,
                        { character: 'Q' },
                        { character: 'W' },
                        { character: 'E' },
                        { character: 'R' },
                        { character: 'T' },
                        { character: 'Y' },
                        { character: 'U' },
                        { character: 'I' },
                        { character: 'O' },
                        { character: 'P' },
                        { ok: true, icon: 'check_circle' }
                    ], [
                        { set: 'lower', span: 2 },
                        { character: 'A' },
                        { character: 'S' },
                        { character: 'D' },
                        { character: 'F' },
                        { character: 'G' },
                        { character: 'H' },
                        { character: 'J' },
                        { character: 'K' },
                        { character: 'L' }
                    ], [
                        { set: 'symbols', span: 2 },
                        { character: 'Z' },
                        { character: 'X' },
                        { character: 'C' },
                        { character: 'V' },
                        { character: 'B' },
                        { character: 'N' },
                        { character: 'M' }
                    ], [
                        null,
                        null,
                        null,
                        null,
                        { space: true, span: 4 }
                    ]
                ] },
            symbols: { label: '@#*', keys: [
                    [
                        { cancel: true, icon: 'cancel' },
                        { character: '!' },
                        { character: '"' },
                        { character: '£' },
                        { character: '$' },
                        { character: '%' },
                        { character: '^' },
                        { character: '&' },
                        { character: '*' },
                        { character: '(' },
                        { character: ')' },
                        { backspace: true, icon: 'backspace' }
                    ], [
                        null,
                        { character: '-' },
                        { character: '=' },
                        { character: '_' },
                        { character: '+' },
                        { character: '[' },
                        { character: ']' },
                        { character: '{' },
                        { character: '}' },
                        { character: ';' },
                        { character: '\'' },
                        { ok: true, icon: 'check_circle' }
                    ], [
                        null,
                        null,
                        { character: '#' },
                        { character: ':' },
                        { character: '@' },
                        { character: '~' },
                        { character: ',' },
                        { character: '.' },
                        { character: '/' },
                        { character: '<' },
                        { character: '>' }
                    ], [
                        { set: 'lower', span: 2 },
                        { character: '?' },
                        { character: '`' },
                        { character: '¬' },
                        { character: '|' }
                    ], [
                        null,
                        null,
                        null,
                        null,
                        { space: true, span: 4 }
                    ]
                ] }
        }
    };
    var SIMPLE_KEYBOARD = {
        default: 'alphanumeric',
        sets: {
            alphanumeric: { label: 'AZ09', keys: [
                    [
                        { character: '1' },
                        { character: '2' },
                        { character: '3' },
                        { character: '4' },
                        { character: '5' },
                        { character: '6' },
                        { character: '7' },
                        { character: '8' },
                        { character: '9' },
                        { character: '0' }
                    ], [
                        { character: 'Q' },
                        { character: 'W' },
                        { character: 'E' },
                        { character: 'R' },
                        { character: 'T' },
                        { character: 'Y' },
                        { character: 'U' },
                        { character: 'I' },
                        { character: 'O' },
                        { character: 'P' }
                    ], [
                        { character: 'A' },
                        { character: 'S' },
                        { character: 'D' },
                        { character: 'F' },
                        { character: 'G' },
                        { character: 'H' },
                        { character: 'J' },
                        { character: 'K' },
                        { character: 'L' }
                    ], [
                        null,
                        { character: 'Z' },
                        { character: 'X' },
                        { character: 'C' },
                        { character: 'V' },
                        { character: 'B' },
                        { character: 'N' },
                        { character: 'M' }
                    ], [
                        { set: 'symbols', span: 2 },
                        { space: true, span: 4 },
                        { backspace: true, icon: 'backspace' },
                        null,
                        { ok: true, icon: 'check_circle' },
                        { cancel: true, icon: 'cancel' }
                    ]
                ] },
            symbols: { label: '@#*', keys: [
                    [
                        { character: '!' },
                        { character: '"' },
                        { character: '£' },
                        { character: '$' },
                        { character: '%' },
                        { character: '^' },
                        { character: '&' },
                        { character: '*' },
                        { character: '(' },
                        { character: ')' }
                    ], [
                        { character: '-' },
                        { character: '_' },
                        { character: '+' },
                        { character: '=' },
                        { character: '[' },
                        { character: ']' },
                        { character: '{' },
                        { character: '}' }
                    ], [
                        { character: ';' },
                        { character: ':' },
                        { character: '\'' },
                        { character: '@' },
                        { character: '#' },
                        { character: '~' }
                    ], [
                        { character: ',' },
                        { character: '.' },
                        { character: '<' },
                        { character: '>' },
                        { character: '/' },
                        { character: '?' }
                    ], [
                        { set: 'alphanumeric', span: 2 },
                        { space: true, span: 4 },
                        { backspace: true, icon: 'backspace' },
                        null,
                        { ok: true, icon: 'check_circle' },
                        { cancel: true, icon: 'cancel' }
                    ]
                ] }
        }
    };
    var LOGIN_PIN_KEYBOARD = {
        default: 'numeric',
        sets: {
            numeric: { label: '', keys: [
                    [
                        { character: '1' },
                        { character: '2' },
                        { character: '3' }
                    ], [
                        { character: '4' },
                        { character: '5' },
                        { character: '6' }
                    ], [
                        { character: '7' },
                        { character: '8' },
                        { character: '9' }
                    ], [
                        { backspace: true, icon: 'backspace' },
                        { character: '0' },
                        { ok: true, icon: 'check_circle' }
                    ]
                ] }
        }
    };

    var CommonsEditorService = /** @class */ (function () {
        function CommonsEditorService(drawerService) {
            this.drawerService = drawerService;
            this.showEmitter = new core.EventEmitter(true);
            this.hideEmitter = new core.EventEmitter(true);
        }
        CommonsEditorService.prototype.edit = function (value, settings, ok, cancel) {
            var _this = this;
            this.showEmitter.emit({
                value: value,
                settings: settings,
                ok: function (v) {
                    _this.hide();
                    ok(v);
                },
                cancel: function () {
                    _this.hide();
                    if (cancel)
                        cancel();
                }
            });
            this.drawerService.show('_editor');
        };
        CommonsEditorService.prototype.hide = function () {
            var _this = this;
            this.drawerService.hide('_editor');
            setTimeout(function () { _this.hideEmitter.emit(); }, 250); // wait for the 200ms animation to finish
        };
        CommonsEditorService.prototype.showObservable = function () {
            return this.showEmitter;
        };
        CommonsEditorService.prototype.hideObservable = function () {
            return this.hideEmitter;
        };
        CommonsEditorService.ctorParameters = function () { return [
            { type: ngxWebappcommonsMobile.CommonsDrawerService }
        ]; };
        CommonsEditorService = __decorate([
            core.Injectable()
        ], CommonsEditorService);
        return CommonsEditorService;
    }());

    var CommonsKeyboardKeyComponent = /** @class */ (function (_super) {
        __extends(CommonsKeyboardKeyComponent, _super);
        function CommonsKeyboardKeyComponent() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.setLabels = {};
            _this.disabled = false;
            _this.disableThemeInvert = false;
            _this.onCharacter = new core.EventEmitter(true);
            _this.onSpace = new core.EventEmitter(true);
            _this.onOk = new core.EventEmitter(true);
            _this.onCancel = new core.EventEmitter(true);
            _this.onBackspace = new core.EventEmitter(true);
            _this.onSet = new core.EventEmitter(true);
            return _this;
        }
        CommonsKeyboardKeyComponent.prototype.doClick = function () {
            if (this.key.cancel) {
                this.onCancel.emit();
                return;
            }
            if (this.key.space) {
                this.onSpace.emit();
                return;
            }
            if (this.key.ok) {
                this.onOk.emit();
                return;
            }
            if (this.key.backspace) {
                this.onBackspace.emit();
                return;
            }
            if (this.key.set !== undefined) {
                this.onSet.emit(this.key.set);
                return;
            }
            if (this.key.character !== undefined) {
                this.onCharacter.emit(this.key.character);
                return;
            }
        };
        __decorate([
            core.Input()
        ], CommonsKeyboardKeyComponent.prototype, "key", void 0);
        __decorate([
            core.Input()
        ], CommonsKeyboardKeyComponent.prototype, "setLabels", void 0);
        __decorate([
            core.Input()
        ], CommonsKeyboardKeyComponent.prototype, "disabled", void 0);
        __decorate([
            core.Input()
        ], CommonsKeyboardKeyComponent.prototype, "disableThemeInvert", void 0);
        __decorate([
            core.Input()
        ], CommonsKeyboardKeyComponent.prototype, "maxColumns", void 0);
        __decorate([
            core.Output()
        ], CommonsKeyboardKeyComponent.prototype, "onCharacter", void 0);
        __decorate([
            core.Output()
        ], CommonsKeyboardKeyComponent.prototype, "onSpace", void 0);
        __decorate([
            core.Output()
        ], CommonsKeyboardKeyComponent.prototype, "onOk", void 0);
        __decorate([
            core.Output()
        ], CommonsKeyboardKeyComponent.prototype, "onCancel", void 0);
        __decorate([
            core.Output()
        ], CommonsKeyboardKeyComponent.prototype, "onBackspace", void 0);
        __decorate([
            core.Output()
        ], CommonsKeyboardKeyComponent.prototype, "onSet", void 0);
        CommonsKeyboardKeyComponent = __decorate([
            core.Component({
                selector: 'commons-keyboard-key',
                template: "<button\n\t\t[class]=\"'keyboard columns-' + this.maxColumns\"\n\t\t[class.span2]=\"this.key.span === 2\"\n\t\t[class.span3]=\"this.key.span === 3\"\n\t\t[class.span4]=\"this.key.span === 4\"\n\t\t[class.space]=\"this.key.space\"\n\t\t[class.set]=\"this.key.set\"\n\t\t[class.secondary]=\"this.key.ok\"\n\t\t[class.disableThemeInvert]=\"this.disableThemeInvert\"\n\t\t[disabled]=\"this.disabled\"\n\t\t(click)=\"this.doClick()\"\n>\n\t<i *ngIf=\"this.key.icon\" class=\"material-icons\">{{this.key.icon}}</i>\n\t<ng-container *ngIf=\"this.key.set\">{{this.setLabels[this.key.set]}}</ng-container>\n\t<ng-container *ngIf=\"this.key.character !== undefined\">{{this.key.character}}</ng-container>\n</button>\n",
                styles: ["@charset 'utf8';button{-webkit-appearance:none;-moz-appearance:none;appearance:none;font-family:Roboto;font-size:16px;line-height:16px;font-weight:500;box-sizing:border-box;padding:0;width:100%;height:43px;min-width:0;overflow:hidden;border:0;border-radius:2px;margin:0;outline:0}button.space{margin:10px 0;height:23px}button.set{padding-top:1px;font-size:14px;font-weight:500}:host-context(body.webappcommons-theme-blue) button{background-color:transparent;color:#333}:host-context(body.webappcommons-theme-blue) button.secondary{color:#ffc107}:host-context(body.webappcommons-theme-blue) button:active{background-color:#ffc107;color:#000}:host-context(body.webappcommons-theme-blue) button:disabled{color:#c2c2c2}:host-context(body.webappcommons-theme-blue) button:disabled.disableThemeInvert{color:rgba(145,145,145,.75)}:host-context(body.webappcommons-theme-blue) button.space{background:#bfbfbf}:host-context(body.webappcommons-theme-blue) button.space:active{background:#ffc107}:host-context(body.webappcommons-theme-darkred) button{background-color:transparent;color:#b8b8b8}:host-context(body.webappcommons-theme-darkred) button.secondary{color:#ffeb3b}:host-context(body.webappcommons-theme-darkred) button:active{background-color:#ffeb3b;color:#000}:host-context(body.webappcommons-theme-darkred) button:disabled{color:#4e4e4e}:host-context(body.webappcommons-theme-darkred) button:disabled.disableThemeInvert{color:rgba(114,114,114,.75)}:host-context(body.webappcommons-theme-darkred) button.space{background:#505050}:host-context(body.webappcommons-theme-darkred) button.space:active{background:#ffeb3b}:host-context(body.webappcommons-theme-hotpink) button{background-color:transparent;color:#333}:host-context(body.webappcommons-theme-hotpink) button.secondary{color:#9debef}:host-context(body.webappcommons-theme-hotpink) button:active{background-color:#9debef;color:#000}:host-context(body.webappcommons-theme-hotpink) button:disabled{color:#c2c2c2}:host-context(body.webappcommons-theme-hotpink) button:disabled.disableThemeInvert{color:rgba(145,145,145,.75)}:host-context(body.webappcommons-theme-hotpink) button.space{background:#bfbfbf}:host-context(body.webappcommons-theme-hotpink) button.space:active{background:#9debef}:host-context(body.webappcommons-theme-marine) button{background-color:transparent;color:#333}:host-context(body.webappcommons-theme-marine) button.secondary{color:#99d1dd}:host-context(body.webappcommons-theme-marine) button:active{background-color:#99d1dd;color:#000}:host-context(body.webappcommons-theme-marine) button:disabled{color:#c2c2c2}:host-context(body.webappcommons-theme-marine) button:disabled.disableThemeInvert{color:rgba(145,145,145,.75)}:host-context(body.webappcommons-theme-marine) button.space{background:#bfbfbf}:host-context(body.webappcommons-theme-marine) button.space:active{background:#99d1dd}:host-context(body.webappcommons-theme-muted) button{background-color:transparent;color:#333}:host-context(body.webappcommons-theme-muted) button.secondary{color:#fdd835}:host-context(body.webappcommons-theme-muted) button:active{background-color:#fdd835;color:#000}:host-context(body.webappcommons-theme-muted) button:disabled{color:#c2c2c2}:host-context(body.webappcommons-theme-muted) button:disabled.disableThemeInvert{color:rgba(145,145,145,.75)}:host-context(body.webappcommons-theme-muted) button.space{background:#bfbfbf}:host-context(body.webappcommons-theme-muted) button.space:active{background:#fdd835}:host-context(body.webappcommons-theme-night) button{background-color:transparent;color:#333}:host-context(body.webappcommons-theme-night) button.secondary{color:#e7c385}:host-context(body.webappcommons-theme-night) button:active{background-color:#e7c385;color:#000}:host-context(body.webappcommons-theme-night) button:disabled{color:#c2c2c2}:host-context(body.webappcommons-theme-night) button:disabled.disableThemeInvert{color:rgba(145,145,145,.75)}:host-context(body.webappcommons-theme-night) button.space{background:#bfbfbf}:host-context(body.webappcommons-theme-night) button.space:active{background:#e7c385}:host-context(body.webappcommons-theme-patrolred) button{background-color:transparent;color:#333}:host-context(body.webappcommons-theme-patrolred) button.secondary{color:#90a4ae}:host-context(body.webappcommons-theme-patrolred) button:active{background-color:#90a4ae;color:#fff}:host-context(body.webappcommons-theme-patrolred) button:disabled{color:#c2c2c2}:host-context(body.webappcommons-theme-patrolred) button:disabled.disableThemeInvert{color:rgba(145,145,145,.75)}:host-context(body.webappcommons-theme-patrolred) button.space{background:#bfbfbf}:host-context(body.webappcommons-theme-patrolred) button.space:active{background:#90a4ae}:host-context(body.webappcommons-theme-purple) button{background-color:transparent;color:#333}:host-context(body.webappcommons-theme-purple) button.secondary{color:#fc3}:host-context(body.webappcommons-theme-purple) button:active{background-color:#fc3;color:#000}:host-context(body.webappcommons-theme-purple) button:disabled{color:#c2c2c2}:host-context(body.webappcommons-theme-purple) button:disabled.disableThemeInvert{color:rgba(145,145,145,.75)}:host-context(body.webappcommons-theme-purple) button.space{background:#bfbfbf}:host-context(body.webappcommons-theme-purple) button.space:active{background:#fc3}"]
            })
        ], CommonsKeyboardKeyComponent);
        return CommonsKeyboardKeyComponent;
    }(ngxAngularcommonsCore.CommonsComponent));

    var CommonsKeyboardComponent = /** @class */ (function (_super) {
        __extends(CommonsKeyboardComponent, _super);
        function CommonsKeyboardComponent() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.disableOk = false;
            _this.disableCancel = false;
            _this.disableBackspace = false;
            _this.disableCharacters = false;
            _this.disableThemeInvert = false;
            _this.onCharacter = new core.EventEmitter(true);
            _this.onOk = new core.EventEmitter(true);
            _this.onCancel = new core.EventEmitter(true);
            _this.onBackspace = new core.EventEmitter(true);
            _this.set = undefined;
            _this.maxColumns = 0;
            return _this;
        }
        CommonsKeyboardComponent.prototype.ngOnInit = function () {
            var e_1, _a, e_2, _b, e_3, _c;
            _super.prototype.ngOnInit.call(this);
            this.set = this.keyboard.default;
            this.maxColumns = 0;
            try {
                for (var _d = __values(Object.keys(this.keyboard.sets)), _e = _d.next(); !_e.done; _e = _d.next()) {
                    var set = _e.value;
                    try {
                        for (var _f = (e_2 = void 0, __values(this.keyboard.sets[set].keys)), _g = _f.next(); !_g.done; _g = _f.next()) {
                            var row = _g.value;
                            var max = 0;
                            try {
                                for (var row_1 = (e_3 = void 0, __values(row)), row_1_1 = row_1.next(); !row_1_1.done; row_1_1 = row_1.next()) {
                                    var key = row_1_1.value;
                                    if (key && key.span)
                                        max += key.span;
                                    else
                                        max++;
                                }
                            }
                            catch (e_3_1) { e_3 = { error: e_3_1 }; }
                            finally {
                                try {
                                    if (row_1_1 && !row_1_1.done && (_c = row_1.return)) _c.call(row_1);
                                }
                                finally { if (e_3) throw e_3.error; }
                            }
                            this.maxColumns = Math.max(this.maxColumns, max);
                        }
                    }
                    catch (e_2_1) { e_2 = { error: e_2_1 }; }
                    finally {
                        try {
                            if (_g && !_g.done && (_b = _f.return)) _b.call(_f);
                        }
                        finally { if (e_2) throw e_2.error; }
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_e && !_e.done && (_a = _d.return)) _a.call(_d);
                }
                finally { if (e_1) throw e_1.error; }
            }
        };
        CommonsKeyboardComponent.prototype.setLabels = function () {
            var e_4, _a;
            var labels = {};
            try {
                for (var _b = __values(Object.keys(this.keyboard.sets)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var setName = _c.value;
                    labels[setName] = this.keyboard.sets[setName].label;
                }
            }
            catch (e_4_1) { e_4 = { error: e_4_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_4) throw e_4.error; }
            }
            return labels;
        };
        CommonsKeyboardComponent.prototype.isDisabled = function (key) {
            if (key.ok && this.disableOk)
                return true;
            if (key.backspace && this.disableBackspace)
                return true;
            if (key.cancel && this.disableCancel)
                return true;
            if ((key.character || key.space) && this.disableCharacters)
                return true;
            return false;
        };
        CommonsKeyboardComponent.prototype.doChangeSet = function (set) {
            this.set = set;
        };
        __decorate([
            core.Input()
        ], CommonsKeyboardComponent.prototype, "keyboard", void 0);
        __decorate([
            core.Input()
        ], CommonsKeyboardComponent.prototype, "disableOk", void 0);
        __decorate([
            core.Input()
        ], CommonsKeyboardComponent.prototype, "disableCancel", void 0);
        __decorate([
            core.Input()
        ], CommonsKeyboardComponent.prototype, "disableBackspace", void 0);
        __decorate([
            core.Input()
        ], CommonsKeyboardComponent.prototype, "disableCharacters", void 0);
        __decorate([
            core.Input()
        ], CommonsKeyboardComponent.prototype, "disableThemeInvert", void 0);
        __decorate([
            core.Output()
        ], CommonsKeyboardComponent.prototype, "onCharacter", void 0);
        __decorate([
            core.Output()
        ], CommonsKeyboardComponent.prototype, "onOk", void 0);
        __decorate([
            core.Output()
        ], CommonsKeyboardComponent.prototype, "onCancel", void 0);
        __decorate([
            core.Output()
        ], CommonsKeyboardComponent.prototype, "onBackspace", void 0);
        CommonsKeyboardComponent = __decorate([
            core.Component({
                selector: 'commons-keyboard',
                template: "<aside><ul *ngIf=\"this.set\"\n\t\t[class]=\"'columns-' + this.maxColumns\"\n>\n\t<li row *ngFor=\"let row of this.keyboard.sets[this.set].keys\">\n\t\t<ul>\n\t\t\t<li column *ngFor=\"let key of row\"\n\t\t\t\t\t[class.filler]=\"!key\"\n\t\t\t\t\t[class.span-2]=\"key && key.span === 2\"\n\t\t\t\t\t[class.span-3]=\"key && key.span === 3\"\n\t\t\t\t\t[class.span-4]=\"key && key.span === 4\"\n\t\t\t>\n\t\t\t\t<commons-keyboard-key *ngIf=\"key\"\n\t\t\t\t\t\t[key]=\"key\"\n\t\t\t\t\t\t[setLabels]=\"this.setLabels()\"\n\t\t\t\t\t\t[disabled]=\"this.isDisabled(key)\"\n\t\t\t\t\t\t[disableThemeInvert]=\"this.disableThemeInvert\"\n\t\t\t\t\t\t[maxColumns]=\"this.maxColumns\"\n\t\t\t\t\t\t(onCharacter)=\"this.onCharacter.emit($event);\"\n\t\t\t\t\t\t(onSet)=\"this.doChangeSet($event);\"\n\t\t\t\t\t\t(onSpace)=\"this.onCharacter.emit(' ');\"\n\t\t\t\t\t\t(onOk)=\"this.onOk.emit();\"\n\t\t\t\t\t\t(onCancel)=\"this.onCancel.emit();\"\n\t\t\t\t\t\t(onBackspace)=\"this.onBackspace.emit();\"\n\t\t\t\t></commons-keyboard-key>\n\t\t\t</li>\n\t\t</ul>\n\t</li>\n</ul></aside>",
                styles: ["@charset 'utf8';aside{width:100%;display:block}aside>ul{margin:0 auto}aside>ul.columns-0{width:100%;min-width:0;max-width:0}aside>ul.columns-0 li[column]{width:calc(100% / 0);min-width:25px;max-width:60px}aside>ul.columns-0 li[column].span-2{width:calc(200% / 0);min-width:50px;max-width:120px}aside>ul.columns-0 li[column].span-3{width:calc(300% / 0);min-width:75px;max-width:180px}aside>ul.columns-0 li[column].span-4{width:calc(400% / 0);min-width:100px;max-width:240px}aside>ul.columns-1{width:100%;min-width:25px;max-width:60px}aside>ul.columns-1 li[column]{width:calc(100% / 1);min-width:25px;max-width:60px}aside>ul.columns-1 li[column].span-2{width:calc(200% / 1);min-width:50px;max-width:120px}aside>ul.columns-1 li[column].span-3{width:calc(300% / 1);min-width:75px;max-width:180px}aside>ul.columns-1 li[column].span-4{width:calc(400% / 1);min-width:100px;max-width:240px}aside>ul.columns-2{width:100%;min-width:50px;max-width:120px}aside>ul.columns-2 li[column]{width:calc(100% / 2);min-width:25px;max-width:60px}aside>ul.columns-2 li[column].span-2{width:calc(200% / 2);min-width:50px;max-width:120px}aside>ul.columns-2 li[column].span-3{width:calc(300% / 2);min-width:75px;max-width:180px}aside>ul.columns-2 li[column].span-4{width:calc(400% / 2);min-width:100px;max-width:240px}aside>ul.columns-3{width:100%;min-width:75px;max-width:180px}aside>ul.columns-3 li[column]{width:calc(100% / 3);min-width:25px;max-width:60px}aside>ul.columns-3 li[column].span-2{width:calc(200% / 3);min-width:50px;max-width:120px}aside>ul.columns-3 li[column].span-3{width:calc(300% / 3);min-width:75px;max-width:180px}aside>ul.columns-3 li[column].span-4{width:calc(400% / 3);min-width:100px;max-width:240px}aside>ul.columns-4{width:100%;min-width:100px;max-width:240px}aside>ul.columns-4 li[column]{width:calc(100% / 4);min-width:25px;max-width:60px}aside>ul.columns-4 li[column].span-2{width:calc(200% / 4);min-width:50px;max-width:120px}aside>ul.columns-4 li[column].span-3{width:calc(300% / 4);min-width:75px;max-width:180px}aside>ul.columns-4 li[column].span-4{width:calc(400% / 4);min-width:100px;max-width:240px}aside>ul.columns-5{width:100%;min-width:125px;max-width:300px}aside>ul.columns-5 li[column]{width:calc(100% / 5);min-width:25px;max-width:60px}aside>ul.columns-5 li[column].span-2{width:calc(200% / 5);min-width:50px;max-width:120px}aside>ul.columns-5 li[column].span-3{width:calc(300% / 5);min-width:75px;max-width:180px}aside>ul.columns-5 li[column].span-4{width:calc(400% / 5);min-width:100px;max-width:240px}aside>ul.columns-6{width:100%;min-width:150px;max-width:360px}aside>ul.columns-6 li[column]{width:calc(100% / 6);min-width:25px;max-width:60px}aside>ul.columns-6 li[column].span-2{width:calc(200% / 6);min-width:50px;max-width:120px}aside>ul.columns-6 li[column].span-3{width:calc(300% / 6);min-width:75px;max-width:180px}aside>ul.columns-6 li[column].span-4{width:calc(400% / 6);min-width:100px;max-width:240px}aside>ul.columns-7{width:100%;min-width:175px;max-width:420px}aside>ul.columns-7 li[column]{width:calc(100% / 7);min-width:25px;max-width:60px}aside>ul.columns-7 li[column].span-2{width:calc(200% / 7);min-width:50px;max-width:120px}aside>ul.columns-7 li[column].span-3{width:calc(300% / 7);min-width:75px;max-width:180px}aside>ul.columns-7 li[column].span-4{width:calc(400% / 7);min-width:100px;max-width:240px}aside>ul.columns-8{width:100%;min-width:200px;max-width:480px}aside>ul.columns-8 li[column]{width:calc(100% / 8);min-width:25px;max-width:60px}aside>ul.columns-8 li[column].span-2{width:calc(200% / 8);min-width:50px;max-width:120px}aside>ul.columns-8 li[column].span-3{width:calc(300% / 8);min-width:75px;max-width:180px}aside>ul.columns-8 li[column].span-4{width:calc(400% / 8);min-width:100px;max-width:240px}aside>ul.columns-9{width:100%;min-width:225px;max-width:540px}aside>ul.columns-9 li[column]{width:calc(100% / 9);min-width:25px;max-width:60px}aside>ul.columns-9 li[column].span-2{width:calc(200% / 9);min-width:50px;max-width:120px}aside>ul.columns-9 li[column].span-3{width:calc(300% / 9);min-width:75px;max-width:180px}aside>ul.columns-9 li[column].span-4{width:calc(400% / 9);min-width:100px;max-width:240px}aside>ul.columns-10{width:100%;min-width:250px;max-width:600px}aside>ul.columns-10 li[column]{width:calc(100% / 10);min-width:25px;max-width:60px}aside>ul.columns-10 li[column].span-2{width:calc(200% / 10);min-width:50px;max-width:120px}aside>ul.columns-10 li[column].span-3{width:calc(300% / 10);min-width:75px;max-width:180px}aside>ul.columns-10 li[column].span-4{width:calc(400% / 10);min-width:100px;max-width:240px}aside>ul.columns-11{width:100%;min-width:275px;max-width:660px}aside>ul.columns-11 li[column]{width:calc(100% / 11);min-width:25px;max-width:60px}aside>ul.columns-11 li[column].span-2{width:calc(200% / 11);min-width:50px;max-width:120px}aside>ul.columns-11 li[column].span-3{width:calc(300% / 11);min-width:75px;max-width:180px}aside>ul.columns-11 li[column].span-4{width:calc(400% / 11);min-width:100px;max-width:240px}aside>ul.columns-12{width:100%;min-width:300px;max-width:720px}aside>ul.columns-12 li[column]{width:calc(100% / 12);min-width:25px;max-width:60px}aside>ul.columns-12 li[column].span-2{width:calc(200% / 12);min-width:50px;max-width:120px}aside>ul.columns-12 li[column].span-3{width:calc(300% / 12);min-width:75px;max-width:180px}aside>ul.columns-12 li[column].span-4{width:calc(400% / 12);min-width:100px;max-width:240px}aside>ul.columns-13{width:100%;min-width:325px;max-width:780px}aside>ul.columns-13 li[column]{width:calc(100% / 13);min-width:25px;max-width:60px}aside>ul.columns-13 li[column].span-2{width:calc(200% / 13);min-width:50px;max-width:120px}aside>ul.columns-13 li[column].span-3{width:calc(300% / 13);min-width:75px;max-width:180px}aside>ul.columns-13 li[column].span-4{width:calc(400% / 13);min-width:100px;max-width:240px}aside>ul.columns-14{width:100%;min-width:350px;max-width:840px}aside>ul.columns-14 li[column]{width:calc(100% / 14);min-width:25px;max-width:60px}aside>ul.columns-14 li[column].span-2{width:calc(200% / 14);min-width:50px;max-width:120px}aside>ul.columns-14 li[column].span-3{width:calc(300% / 14);min-width:75px;max-width:180px}aside>ul.columns-14 li[column].span-4{width:calc(400% / 14);min-width:100px;max-width:240px}aside>ul.columns-15{width:100%;min-width:375px;max-width:900px}aside>ul.columns-15 li[column]{width:calc(100% / 15);min-width:25px;max-width:60px}aside>ul.columns-15 li[column].span-2{width:calc(200% / 15);min-width:50px;max-width:120px}aside>ul.columns-15 li[column].span-3{width:calc(300% / 15);min-width:75px;max-width:180px}aside>ul.columns-15 li[column].span-4{width:calc(400% / 15);min-width:100px;max-width:240px}aside>ul.columns-16{width:100%;min-width:400px;max-width:960px}aside>ul.columns-16 li[column]{width:calc(100% / 16);min-width:25px;max-width:60px}aside>ul.columns-16 li[column].span-2{width:calc(200% / 16);min-width:50px;max-width:120px}aside>ul.columns-16 li[column].span-3{width:calc(300% / 16);min-width:75px;max-width:180px}aside>ul.columns-16 li[column].span-4{width:calc(400% / 16);min-width:100px;max-width:240px}aside>ul.columns-17{width:100%;min-width:425px;max-width:1020px}aside>ul.columns-17 li[column]{width:calc(100% / 17);min-width:25px;max-width:60px}aside>ul.columns-17 li[column].span-2{width:calc(200% / 17);min-width:50px;max-width:120px}aside>ul.columns-17 li[column].span-3{width:calc(300% / 17);min-width:75px;max-width:180px}aside>ul.columns-17 li[column].span-4{width:calc(400% / 17);min-width:100px;max-width:240px}aside>ul.columns-18{width:100%;min-width:450px;max-width:1080px}aside>ul.columns-18 li[column]{width:calc(100% / 18);min-width:25px;max-width:60px}aside>ul.columns-18 li[column].span-2{width:calc(200% / 18);min-width:50px;max-width:120px}aside>ul.columns-18 li[column].span-3{width:calc(300% / 18);min-width:75px;max-width:180px}aside>ul.columns-18 li[column].span-4{width:calc(400% / 18);min-width:100px;max-width:240px}aside>ul.columns-19{width:100%;min-width:475px;max-width:1140px}aside>ul.columns-19 li[column]{width:calc(100% / 19);min-width:25px;max-width:60px}aside>ul.columns-19 li[column].span-2{width:calc(200% / 19);min-width:50px;max-width:120px}aside>ul.columns-19 li[column].span-3{width:calc(300% / 19);min-width:75px;max-width:180px}aside>ul.columns-19 li[column].span-4{width:calc(400% / 19);min-width:100px;max-width:240px}aside>ul.columns-20{width:100%;min-width:500px;max-width:1200px}aside>ul.columns-20 li[column]{width:calc(100% / 20);min-width:25px;max-width:60px}aside>ul.columns-20 li[column].span-2{width:calc(200% / 20);min-width:50px;max-width:120px}aside>ul.columns-20 li[column].span-3{width:calc(300% / 20);min-width:75px;max-width:180px}aside>ul.columns-20 li[column].span-4{width:calc(400% / 20);min-width:100px;max-width:240px}ul{list-style:none;margin:0;padding:0}ul li[row]{clear:both;width:100%;height:43px}ul li[column]{float:left}ul li[column].filler{height:43px}"]
            })
        ], CommonsKeyboardComponent);
        return CommonsKeyboardComponent;
    }(ngxAngularcommonsCore.CommonsComponent));

    var CommonsEditorDisplayComponent = /** @class */ (function (_super) {
        __extends(CommonsEditorDisplayComponent, _super);
        function CommonsEditorDisplayComponent() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.onMove = new core.EventEmitter(true);
            _this.preCharacters = [];
            _this.postCharacters = [];
            return _this;
        }
        CommonsEditorDisplayComponent.prototype.ngOnChanges = function (changes) {
            if (changes.pre !== undefined)
                this.preCharacters = changes.pre.currentValue.split('');
            if (changes.post !== undefined)
                this.postCharacters = changes.post.currentValue.split('');
        };
        CommonsEditorDisplayComponent.prototype.movePre = function (index, event) {
            event.stopPropagation();
            this.onMove.emit(index);
        };
        CommonsEditorDisplayComponent.prototype.movePost = function (index, event) {
            event.stopPropagation();
            this.onMove.emit(this.preCharacters.length + index);
        };
        CommonsEditorDisplayComponent.prototype.moveEnd = function () {
            this.onMove.emit(-1);
        };
        __decorate([
            core.Input()
        ], CommonsEditorDisplayComponent.prototype, "pre", void 0);
        __decorate([
            core.Input()
        ], CommonsEditorDisplayComponent.prototype, "post", void 0);
        __decorate([
            core.Output()
        ], CommonsEditorDisplayComponent.prototype, "onMove", void 0);
        CommonsEditorDisplayComponent = __decorate([
            core.Component({
                selector: 'commons-editor-display',
                template: "<section\n\t\t(click)=\"this.moveEnd();\"\n><span class=\"pre\"><span *ngFor=\"let c of this.preCharacters; let i = index\"\n\t\t(click)=\"this.movePre(i, $event);\"\n>{{c}}</span></span><span class=\"post\"><span *ngFor=\"let c of this.postCharacters; let i = index\"\n\t\t(click)=\"this.movePost(i, $event);\"\n>{{c}}</span></span></section>",
                styles: ["@charset 'utf8';section{font-family:Roboto;font-weight:400;font-size:16px;line-height:16px;white-space:pre;margin:0;height:46px;box-sizing:border-box;padding:15px 10px}:host-context(body.webappcommons-theme-blue) section{background-color:#fff;color:#333}:host-context(body.webappcommons-theme-blue) section>span.pre{border-right:2px solid #ffc107;margin-right:-2px}:host-context(body.webappcommons-theme-blue) section>span>span{padding-left:1px}:host-context(body.webappcommons-theme-darkred) section{background-color:#212121;color:#b8b8b8}:host-context(body.webappcommons-theme-darkred) section>span.pre{border-right:2px solid #ffeb3b;margin-right:-2px}:host-context(body.webappcommons-theme-darkred) section>span>span{padding-left:1px}:host-context(body.webappcommons-theme-hotpink) section{background-color:#fff;color:#333}:host-context(body.webappcommons-theme-hotpink) section>span.pre{border-right:2px solid #9debef;margin-right:-2px}:host-context(body.webappcommons-theme-hotpink) section>span>span{padding-left:1px}:host-context(body.webappcommons-theme-marine) section{background-color:#fff;color:#333}:host-context(body.webappcommons-theme-marine) section>span.pre{border-right:2px solid #99d1dd;margin-right:-2px}:host-context(body.webappcommons-theme-marine) section>span>span{padding-left:1px}:host-context(body.webappcommons-theme-muted) section{background-color:#fff;color:#333}:host-context(body.webappcommons-theme-muted) section>span.pre{border-right:2px solid #fdd835;margin-right:-2px}:host-context(body.webappcommons-theme-muted) section>span>span{padding-left:1px}:host-context(body.webappcommons-theme-night) section{background-color:#fff;color:#333}:host-context(body.webappcommons-theme-night) section>span.pre{border-right:2px solid #e7c385;margin-right:-2px}:host-context(body.webappcommons-theme-night) section>span>span{padding-left:1px}:host-context(body.webappcommons-theme-patrolred) section{background-color:#fff;color:#333}:host-context(body.webappcommons-theme-patrolred) section>span.pre{border-right:2px solid #90a4ae;margin-right:-2px}:host-context(body.webappcommons-theme-patrolred) section>span>span{padding-left:1px}:host-context(body.webappcommons-theme-purple) section{background-color:#fff;color:#333}:host-context(body.webappcommons-theme-purple) section>span.pre{border-right:2px solid #fc3;margin-right:-2px}:host-context(body.webappcommons-theme-purple) section>span>span{padding-left:1px}"]
            })
        ], CommonsEditorDisplayComponent);
        return CommonsEditorDisplayComponent;
    }(ngxAngularcommonsCore.CommonsComponent));

    var CommonsEditorComponent = /** @class */ (function (_super) {
        __extends(CommonsEditorComponent, _super);
        function CommonsEditorComponent() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.value = '';
            _this.allowEmpty = false;
            _this.maxLength = 255;
            _this.minLength = 0;
            _this.onCancel = new core.EventEmitter(true);
            _this.onOk = new core.EventEmitter(true);
            _this.characters = [];
            _this.position = 0;
            _this.pre = '';
            _this.post = '';
            return _this;
        }
        CommonsEditorComponent.prototype.ngOnInit = function () {
            _super.prototype.ngOnInit.call(this);
            this.characters = this.value.split('');
            this.position = this.characters.length;
            this.rebuild();
        };
        CommonsEditorComponent.prototype.ngOnChanges = function () {
            this.characters = this.value.split('');
            this.position = this.characters.length;
            this.rebuild();
        };
        CommonsEditorComponent.prototype.rebuild = function () {
            this.pre = this.characters.slice(0, this.position).join('');
            this.post = this.characters.slice(this.position).join('');
        };
        CommonsEditorComponent.prototype.append = function (character) {
            this.characters.splice(this.position, 0, character);
            this.position++;
            this.rebuild();
        };
        CommonsEditorComponent.prototype.doCharacter = function (character) {
            this.append(character);
        };
        CommonsEditorComponent.prototype.doOk = function () {
            this.onOk.emit(this.pre + this.post);
        };
        CommonsEditorComponent.prototype.doCancel = function () {
            this.onCancel.emit();
        };
        CommonsEditorComponent.prototype.doBackspace = function () {
            if (this.position === 0)
                return;
            this.position--;
            this.characters.splice(this.position, 1);
            this.rebuild();
        };
        CommonsEditorComponent.prototype.doMove = function (index) {
            this.position = index === -1 ? this.characters.length : index;
            this.rebuild();
        };
        __decorate([
            core.Input()
        ], CommonsEditorComponent.prototype, "value", void 0);
        __decorate([
            core.Input()
        ], CommonsEditorComponent.prototype, "allowEmpty", void 0);
        __decorate([
            core.Input()
        ], CommonsEditorComponent.prototype, "maxLength", void 0);
        __decorate([
            core.Input()
        ], CommonsEditorComponent.prototype, "minLength", void 0);
        __decorate([
            core.Input()
        ], CommonsEditorComponent.prototype, "keyboard", void 0);
        __decorate([
            core.Output()
        ], CommonsEditorComponent.prototype, "onCancel", void 0);
        __decorate([
            core.Output()
        ], CommonsEditorComponent.prototype, "onOk", void 0);
        CommonsEditorComponent = __decorate([
            core.Component({
                selector: 'commons-editor',
                template: "<aside>\n\t<commons-editor-display\n\t\t\t[pre]=\"this.pre\"\n\t\t\t[post]=\"this.post\"\n\t\t\t(onMove)=\"this.doMove($event);\"\n\t></commons-editor-display>\n\t<commons-keyboard\n\t\t\t[keyboard]=\"this.keyboard\"\n\t\t\t[disableOk]=\"!this.allowEmpty && this.characters.length < this.minLength\"\n\t\t\t[disableBackspace]=\"!this.characters.length\"\n\t\t\t[disableCharacters]=\"this.characters.length >= this.maxLength\"\n\t\t\t(onCharacter)=\"this.doCharacter($event);\"\n\t\t\t(onOk)=\"this.doOk();\"\n\t\t\t(onCancel)=\"this.doCancel();\"\n\t\t\t(onBackspace)=\"this.doBackspace();\"\n\t></commons-keyboard>\n</aside>\n",
                styles: ["@charset 'utf8';aside{display:block}:host-context(body.webappcommons-theme-blue) aside{background-color:#f2f2f2}:host-context(body.webappcommons-theme-darkred) aside{background-color:#2a2a2a}:host-context(body.webappcommons-theme-hotpink) aside{background-color:#f2f2f2}:host-context(body.webappcommons-theme-marine) aside{background-color:#f2f2f2}:host-context(body.webappcommons-theme-muted) aside{background-color:#f2f2f2}:host-context(body.webappcommons-theme-night) aside{background-color:#f2f2f2}:host-context(body.webappcommons-theme-patrolred) aside{background-color:#f2f2f2}:host-context(body.webappcommons-theme-purple) aside{background-color:#f2f2f2}"]
            })
        ], CommonsEditorComponent);
        return CommonsEditorComponent;
    }(ngxAngularcommonsCore.CommonsComponent));

    var CommonsDrawerEditorComponent = /** @class */ (function (_super) {
        __extends(CommonsDrawerEditorComponent, _super);
        function CommonsDrawerEditorComponent(editorService) {
            var _this = _super.call(this) || this;
            _this.editorService = editorService;
            _this.ECommonsDrawerDirection = ngxWebappcommonsMobile.ECommonsDrawerDirection;
            _this.show = false;
            _this.value = '';
            _this.allowEmpty = false;
            _this.maxLength = 255;
            _this.minLength = 0;
            _this.keyboard = undefined;
            // these are simply placeholders that are replaced by the subscription data, so for now don't do anything
            _this.ok = function (_) {
                // do nothing
            };
            _this.cancel = function () {
                // do nothing
            };
            return _this;
        }
        CommonsDrawerEditorComponent.prototype.ngOnInit = function () {
            var _this = this;
            _super.prototype.ngOnInit.call(this);
            this.subscribe(this.editorService.showObservable(), function (data) {
                _this.value = data.value;
                _this.keyboard = data.settings.keyboard;
                _this.allowEmpty = data.settings.allowEmpty || false;
                _this.maxLength = data.settings.maxLength || 255;
                _this.minLength = data.settings.minLength || 0;
                _this.ok = data.ok;
                _this.cancel = data.cancel;
                _this.show = true;
            });
            this.subscribe(this.editorService.hideObservable(), function () {
                _this.show = false;
            });
        };
        CommonsDrawerEditorComponent.prototype.doCancel = function () {
            this.cancel();
        };
        CommonsDrawerEditorComponent.prototype.doOk = function (value) {
            this.ok(value);
        };
        CommonsDrawerEditorComponent.ctorParameters = function () { return [
            { type: CommonsEditorService }
        ]; };
        CommonsDrawerEditorComponent = __decorate([
            core.Component({
                selector: 'commons-drawer-editor',
                template: "<commons-drawer\n\t\t[name]=\"'_editor'\"\n\t\t[direction]=\"ECommonsDrawerDirection.BOTTOM\"\n>\n\t<section><commons-editor *ngIf=\"this.show\"\n\t\t\t[keyboard]=\"this.keyboard\"\n\t\t\t[value]=\"this.value\"\n\t\t\t[allowEmpty]=\"this.allowEmpty\"\n\t\t\t[maxLength]=\"this.maxLength\"\n\t\t\t[minLength]=\"this.minLength\"\n\t\t\t(onCancel)=\"this.doCancel();\"\n\t\t\t(onOk)=\"this.doOk($event);\"\n\t></commons-editor></section>\n</commons-drawer>\n",
                styles: ["@charset 'utf8';section{width:100vw}"]
            })
        ], CommonsDrawerEditorComponent);
        return CommonsDrawerEditorComponent;
    }(ngxAngularcommonsCore.CommonsComponent));

    var NgxWebAppCommonsKeyboardModule = /** @class */ (function () {
        function NgxWebAppCommonsKeyboardModule() {
        }
        NgxWebAppCommonsKeyboardModule_1 = NgxWebAppCommonsKeyboardModule;
        NgxWebAppCommonsKeyboardModule.forRoot = function () {
            return {
                ngModule: NgxWebAppCommonsKeyboardModule_1,
                providers: [
                    CommonsEditorService
                ]
            };
        };
        var NgxWebAppCommonsKeyboardModule_1;
        NgxWebAppCommonsKeyboardModule = NgxWebAppCommonsKeyboardModule_1 = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    ngxWebappcommonsCore.NgxWebAppCommonsCoreModule,
                    ngxWebappcommonsMobile.NgxWebAppCommonsMobileModule
                ],
                declarations: [
                    CommonsKeyboardKeyComponent,
                    CommonsKeyboardComponent,
                    CommonsEditorComponent,
                    CommonsEditorDisplayComponent,
                    CommonsDrawerEditorComponent
                ],
                exports: [
                    CommonsKeyboardComponent,
                    CommonsEditorComponent,
                    CommonsDrawerEditorComponent
                ]
            })
        ], NgxWebAppCommonsKeyboardModule);
        return NgxWebAppCommonsKeyboardModule;
    }());

    exports.CommonsDrawerEditorComponent = CommonsDrawerEditorComponent;
    exports.CommonsEditorComponent = CommonsEditorComponent;
    exports.CommonsEditorDisplayComponent = CommonsEditorDisplayComponent;
    exports.CommonsEditorService = CommonsEditorService;
    exports.CommonsKeyboardComponent = CommonsKeyboardComponent;
    exports.CommonsKeyboardKeyComponent = CommonsKeyboardKeyComponent;
    exports.FULL_KEYBOARD = FULL_KEYBOARD;
    exports.LOGIN_PIN_KEYBOARD = LOGIN_PIN_KEYBOARD;
    exports.NgxWebAppCommonsKeyboardModule = NgxWebAppCommonsKeyboardModule;
    exports.SIMPLE_KEYBOARD = SIMPLE_KEYBOARD;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-webappcommons-keyboard.umd.js.map
