import { OnInit } from '@angular/core';
import { CommonsComponent } from 'ngx-angularcommons-core';
import { ECommonsDrawerDirection } from 'ngx-webappcommons-mobile';
import { CommonsEditorService } from '../../services/commons-editor.service';
import { ICommonsKeyboard } from '../../interfaces/icommons-keyboard';
export declare class CommonsDrawerEditorComponent extends CommonsComponent implements OnInit {
    private editorService;
    ECommonsDrawerDirection: typeof ECommonsDrawerDirection;
    show: boolean;
    value: string;
    allowEmpty: boolean;
    maxLength: number;
    minLength: number;
    keyboard: ICommonsKeyboard | undefined;
    ok: (_: string) => void;
    cancel: () => void;
    constructor(editorService: CommonsEditorService);
    ngOnInit(): void;
    doCancel(): void;
    doOk(value: string): void;
}
