import { EventEmitter, OnInit, OnChanges } from '@angular/core';
import { CommonsComponent } from 'ngx-angularcommons-core';
import { ICommonsKeyboard } from '../../interfaces/icommons-keyboard';
export declare class CommonsEditorComponent extends CommonsComponent implements OnInit, OnChanges {
    value: string;
    allowEmpty: boolean;
    maxLength: number;
    minLength: number;
    keyboard: ICommonsKeyboard;
    onCancel: EventEmitter<void>;
    onOk: EventEmitter<string>;
    characters: string[];
    private position;
    pre: string;
    post: string;
    ngOnInit(): void;
    ngOnChanges(): void;
    private rebuild;
    private append;
    doCharacter(character: string): void;
    doOk(): void;
    doCancel(): void;
    doBackspace(): void;
    doMove(index: number): void;
}
