import { EventEmitter } from '@angular/core';
import { CommonsComponent } from 'ngx-angularcommons-core';
import { ICommonsKeyboardKey } from '../../interfaces/icommons-keyboard-key';
export declare class CommonsKeyboardKeyComponent extends CommonsComponent {
    key: ICommonsKeyboardKey;
    setLabels: {};
    disabled: boolean;
    disableThemeInvert: boolean;
    maxColumns: number;
    onCharacter: EventEmitter<string>;
    onSpace: EventEmitter<void>;
    onOk: EventEmitter<void>;
    onCancel: EventEmitter<void>;
    onBackspace: EventEmitter<void>;
    onSet: EventEmitter<string>;
    doClick(): void;
}
