import { OnInit, EventEmitter } from '@angular/core';
import { CommonsComponent } from 'ngx-angularcommons-core';
import { ICommonsKeyboard } from '../../interfaces/icommons-keyboard';
import { ICommonsKeyboardKey } from '../../interfaces/icommons-keyboard-key';
export declare class CommonsKeyboardComponent extends CommonsComponent implements OnInit {
    keyboard: ICommonsKeyboard;
    disableOk: boolean;
    disableCancel: boolean;
    disableBackspace: boolean;
    disableCharacters: boolean;
    disableThemeInvert: boolean;
    onCharacter: EventEmitter<string>;
    onOk: EventEmitter<void>;
    onCancel: EventEmitter<void>;
    onBackspace: EventEmitter<void>;
    set: string | undefined;
    maxColumns: number;
    ngOnInit(): void;
    setLabels(): {};
    isDisabled(key: ICommonsKeyboardKey): boolean;
    doChangeSet(set: string): void;
}
